CCM = {}

local Addon = CCM
local initialized = false

local MACRO_CCM = L"/script CCM.Switch()"

function CCM.OnInitialize()

  initialized = true
	
  RegisterEventHandler(SystemData.Events.USER_SETTINGS_CHANGED, "CCM.UpdateUI")
  
  CreateWindow ("CCMGUI", true)
	LayoutEditor.RegisterWindow ("CCMGUI", L"CCM", L"CCM", false, false, true, nil)
  
	LibSlash.RegisterSlashCmd("CCM", function() CCM.Switch() end)

  LabelSetText("CCMGUIB1Label", towstring("1"))
  LabelSetText("CCMGUIB2Label", towstring("2"))
  
  CCM.UpdateUI()
  
  --Create Macro
  CCM.CreateMacro (L"CCM: Switch", MACRO_CCM, 2656)
  
end

function CCM.OnShutdown()

  initialized = false

  UnregisterEventHandler(SystemData.Events.USER_SETTINGS_CHANGED, "CCM.UpdateUI")
  
end

function CCM.Switch()

  if SystemData.Settings.Performance.perfLevel == 5 then
    
    CCM.QuickUpdate(6)
    
    BroadcastEvent( SystemData.Events.USER_SETTINGS_CHANGED )
    
  else
    
    CCM.QuickUpdate(5)
    
    BroadcastEvent( SystemData.Events.USER_SETTINGS_CHANGED )
  end

		--DEBUG( L"CCM:" .. SystemData.Settings.Performance.perfLevel)

end

function CCM.OnMouseOverB1()
  
  Tooltips.CreateTextOnlyTooltip ("CCMGUIB1")
  Tooltips.SetTooltipText (1, 1, L"CCM")
  Tooltips.SetTooltipColorDef( 1, 1, Tooltips.COLOR_HEADING )
	
	local data = {}
    
  if SystemData.Settings.Performance.perfLevel == 5 then
    table.insert (data, L"Custom 1 currently active.")
    Tooltips.SetTooltipColorDef( 2, 1, DefaultColor.XP_COLOR_RESTED )
  end

	table.insert (data, L"Right-click customize Custom 1.")
  table.insert (data, L"Left-click to apply customization.")
  table.insert (data, L"Slash /CCM for quick-switch.")
	
	local k = 2
	for _, d in pairs (data)
	do
		Tooltips.SetTooltipText (k, 1, d)
		k = k + 1
	end
	
	Tooltips.AnchorTooltip (Tooltips.ANCHOR_CURSOR)
	Tooltips.Finalize()
    
end

function CCM.OnMouseOverB2()
  
  Tooltips.CreateTextOnlyTooltip ("CCMGUIB2")
  Tooltips.SetTooltipText (1, 1, L"CCM")
  Tooltips.SetTooltipColorDef( 1, 1, Tooltips.COLOR_HEADING )
	
	local data = {}
    
  if SystemData.Settings.Performance.perfLevel == 6 then
    table.insert (data, L"Custom 2 currently active.")
    Tooltips.SetTooltipColorDef( 2, 1, DefaultColor.XP_COLOR_RESTED )
  end

	table.insert (data, L"Right-click customize Custom 2.")
  table.insert (data, L"Left-click to apply customization.")
  table.insert (data, L"Slash /CCM for quick-switch.")
	
	local k = 2
	for _, d in pairs (data)
	do
		Tooltips.SetTooltipText (k, 1, d)
		k = k + 1
	end
	
	Tooltips.AnchorTooltip (Tooltips.ANCHOR_CURSOR)
	Tooltips.Finalize()
  
end

function CCM.OnLButtonUpB1()

-- Custom 1 index = 5
    CCM.QuickUpdate(5)
    BroadcastEvent( SystemData.Events.USER_SETTINGS_CHANGED )
    CCM.OnMouseOverB1()
end

function CCM.OnLButtonUpB2()
  
-- Custom 2 index = 6
    CCM.QuickUpdate(6)
    BroadcastEvent( SystemData.Events.USER_SETTINGS_CHANGED )
    CCM.OnMouseOverB2()
end

function CCM.OnRButtonUpB1()
  
  EA_Window_CustomizePerformance.CurrCustom = 1
  WindowSetShowing( "EA_Window_CustomizePerformance", true )
  
end

function CCM.OnRButtonUpB2()
  
  EA_Window_CustomizePerformance.CurrCustom = 2
  WindowSetShowing( "EA_Window_CustomizePerformance", true )
  
end
function CCM.UpdateUI()
  
  if SystemData.Settings.Performance.perfLevel == 5 then
    DynamicImageSetTexture ("CCMGUIB1", "CCM_active", 0, 0)
    DynamicImageSetTexture ("CCMGUIB2", "CCM_inactive", 0, 0)
  elseif SystemData.Settings.Performance.perfLevel == 6 then
    DynamicImageSetTexture ("CCMGUIB1", "CCM_inactive", 0, 0)
    DynamicImageSetTexture ("CCMGUIB2", "CCM_active", 0, 0)
  else
    DynamicImageSetTexture ("CCMGUIB1", "CCM_inactive", 0, 0)
    DynamicImageSetTexture ("CCMGUIB2", "CCM_inactive", 0, 0)
  end
  
end

function CCM.QuickUpdate(number)
  
  SystemData.Settings.Performance.perfLevel = number
  SettingsWindowTabVideo.SetCustomPerformance(number)
  ComboBoxSetSelectedMenuItem(SettingsWindowTabVideo.contentsName.."SettingsPerformancePerformanceCombo", number )
  
end

function CCM.CreateMacro (name, text, iconId) --From Enemy Addon
	
	local slot = CCM.GetMacroId (text)
	if (slot) then return slot end

	local macros = DataUtils.GetMacros ()
	for slot = 1, EA_Window_Macro.NUM_MACROS
	do
		if (macros[slot].text == L"")
		then
			CCM.SetMacro (slot, name, text, iconId)
			return slot
		end
	end
end

  function CCM.GetMacroId (text) --From Enemy Addon
	local macros = DataUtils.GetMacros ()
	
	for slot = 1, EA_Window_Macro.NUM_MACROS
	do
		if macros[slot].text == text
		then
			return slot
		end
	end

	return nil
end

function CCM.SetMacro (slot, name, text, iconId) --From Enemy Addon
	SetMacroData (name, text, iconId, slot)
	EA_Window_Macro.UpdateDetails (slot)
end